interface IEither<L1, R1> {
    case<T1>(predicates: {
        left: (value: L1) => T1;
        right: (value: R1) => T1;
    }): T1;
    flatMap<R2>(fn: (r: R1) => IEither<L1, R2>): IEither<L1, R2>;
    isLeft(): boolean;
    isRight(): boolean;
    map<R2>(fn: (r: R1) => R2): IEither<L1, R2>;
    mapLeft<L2>(fn: (r: L1) => L2): IEither<L2, R1>;
    mapRight<R2>(fn: (r: R1) => R2): IEither<L1, R2>;
}
export declare abstract class Either<L1, R1> implements IEither<L1, R1> {
    static left<L1 = unknown, R1 = unknown>(value: L1): Either<L1, R1>;
    static right<L1 = unknown, R1 = unknown>(value: R1): Either<L1, R1>;
    static isLeft<L1, R1>(eit: Either<L1, R1>): boolean;
    static isRight<L1, R1>(eit: Either<L1, R1>): boolean;
    abstract flatMap<R2>(fn: (r: R1) => IEither<L1, R2>): IEither<L1, R2>;
    abstract isLeft(): boolean;
    abstract isRight(): boolean;
    abstract map<R2>(fn: (r: R1) => R2): IEither<L1, R2>;
    abstract mapLeft<L2>(fn: (r: L1) => L2): IEither<L2, R1>;
    abstract mapRight<R2>(fn: (r: R1) => R2): IEither<L1, R2>;
    abstract case<T1>(predicates: {
        left: (value: L1) => T1;
        right: (value: R1) => T1;
    }): T1;
}
export {};
