import { Optional } from "./optional";
declare type Ctor<E extends EnumEntry> = {
    new (...args: never[]): E;
};
declare type CtorEnum<C> = C extends Ctor<infer E> ? E : never;
declare type CtorEnumValue<C> = CtorEnum<C> extends EnumEntry<infer T> ? T : never;
interface IEnumeration<E extends EnumEntry<T>, T> {
    entries: E[];
    values: T[];
    withName: (name: string) => Optional<E>;
    withValue: (value: T) => Optional<E>;
}
export declare type Enumeration<C, E extends EnumEntry<T>, T> = C & IEnumeration<E, T>;
export declare abstract class EnumEntry<T = unknown> {
    static seal<C extends Ctor<E>, T extends CtorEnumValue<C>, E extends EnumEntry<T> = CtorEnum<C>>(c: C): Enumeration<C, E, T>;
    readonly value: T;
    protected constructor(value: T);
}
export {};
