export declare abstract class Functor<A> {
    abstract map<B>(fn: (a: A) => B): Functor<B>;
}
export declare abstract class Apply<A> implements Functor<A> {
    abstract ap<B>(b: Apply<(a: A) => B>): Apply<B>;
    abstract map<B>(fn: (a: A) => B): Apply<B>;
}
export declare abstract class Applicative<A> implements Apply<A> {
    static of<B>(b: B): Applicative<B>;
    abstract ap<B>(b: Applicative<(a: A) => B>): Applicative<B>;
    abstract map<B>(fn: (a: A) => B): Applicative<B>;
}
export declare abstract class Chain<A> implements Apply<A> {
    abstract ap<B>(b: Chain<(a: A) => B>): Chain<B>;
    abstract chain<B>(fn: (a: A) => Chain<B>): Chain<B>;
    abstract flatMap<B>(fn: (a: A) => Chain<B>): Chain<B>;
    abstract map<B>(fn: (a: A) => B): Chain<B>;
}
export declare abstract class Monad<A> implements Applicative<A>, Chain<A> {
    abstract ap<B>(b: Monad<(a: A) => B>): Monad<B>;
    abstract chain<B>(fn: (a: A) => Monad<B>): Monad<B>;
    abstract flatMap<B>(fn: (a: A) => Monad<B>): Monad<B>;
    abstract map<B>(fn: (a: A) => B): Monad<B>;
}
